<?php

namespace Ulmus\Query;

class From extends Fragment {

    const SQL_TOKEN = "FROM";
    
    public int $order = -80;

    public array $tables = [];

    public string $sql;
    
    public function set(array $tables) : self
    {
        $this->tables = $tables;
        
        return $this;
    }

    public function add(/* array|string */ $table) : self
    {
        foreach((array) $table as $alias => $name) {
            $this->tables[$alias] = $name;
        }

        return $this;
    }

    public function render() : string
    {
        return $this->renderSegments([
            static::SQL_TOKEN, $this->sql ?? $this->renderTables($this->tables),
        ]);
    }
}
