<?php

namespace Ulmus\QueryBuilder;

use Ulmus\QueryBuilder;

use Ulmus\Query;

class SqliteQueryBuilder extends QueryBuilder implements Query\QueryBuilderInterface
{
    public function pragma(/*object|Stringable*/ $name, $value = null, bool $callable = false) : self
    {
        if ( null !== ( $pragma = $this->getFragment(Query\Sqlite\Pragma::class) ) ) {
            $pragma->set($name, $value, $callable);
        }
        else {
            $pragma = new Query\Sqlite\Pragma();
            $pragma->set($name, $value, $callable);
            $this->push($pragma);
        }

        return $this;
    }
    
    public function showColumns(string $table) : self
    {
        $this->pragma('table_info', $table, true);

        return $this;
    }

    public function showTables(? string $database = null) : self
    {
        $show = new Query\Show();

        $this->push($show);

        $show->set(Query\Show::SQL_SHOW_TABLES, $database);

        return $this;
    }
}
